{
===============================================================================
  Copyright (©) 2001. Rodax Software.
===============================================================================
  Los contenidos de este fichero son propiedad de Rodax Software titular del
  copyright. Este fichero sólo podrá ser copiado, distribuido y utilizado,
  en su totalidad o en parte, con el permiso escrito de Rodax Software, o de
  acuerdo con los términos y condiciones establecidas en el acuerdo/contrato
  bajo el que se suministra.
  -----------------------------------------------------------------------------
  Web:  www.rodax-software.com
===============================================================================
  Fecha primera versión: 01-10-2001
  Versión actual: 1.0.1
  Fecha versión actual: 05-10-2001
===============================================================================
  Modificaciones:

    Fecha         Comentarios
    ---------------------------------------------------------------------------
    05-10-2001    Al cerrar la búsqueda a veces preguntaba si se quería volver
                  al principio y luego es cuando cerraba.
===============================================================================
}

unit BuscarProveedor;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  RdxBotones, ExtCtrls, StdCtrls, RdxCampos, RdxTitulos,
  RdxBarras, RdxPaneles, RdxFrameProveedores, RdxDBFrame;

type
  TfrBuscarProveedor = class(TRdxFrameProveedores)
    brBuscar: TRdxBarraInferior;
    bBuscar: TRdxBoton;
    bCerrar: TRdxBoton;
    pnlScroll: TRdxScrollPanel;
    cBuscarProveedor: TRdxCabecera;
    eCodigo: TLabel;
    Codigo: TRdxEdit;
    eNIF: TLabel;
    eNombre: TLabel;
    Nombre: TRdxEdit;
    NIFCIF: TRdxEdit;
    procedure bCerrarClick(Sender: TObject);
    procedure bBuscarClick(Sender: TObject);
  private
    procedure RecogerDatos;
  protected
    procedure BuscarProveedor; override;
    function CloseFrame : boolean; override;
  public
    constructor Create (AOwner : TComponent); override;
  published
    property TablaProveedores;
    property BaseDatos;
    property Transaccion;
    property CodigoProveedor;
  end;

var
  frBuscarProveedor: TfrBuscarProveedor;

implementation
{$R *.DFM}

uses
  DB, Tipos, Mensajes, Proveedores, StrFunc, Configuracion, Literales;

var
  Campos : String;
  Valores : Variant;
  Contador : Integer;

constructor TfrBuscarProveedor.Create (AOwner : TComponent);
begin
  if not (AOwner is TRdxFrameProveedores) then
    exit;
  inherited Create(AOwner);
  Entidad := entProveedor;
  ConfigurarFrame(Self, Self.Entidad);

  Contador := -1;
  Campos := '';
  Valores := VarArrayOf([null, null, null]);

  TablaProveedores := (AOwner as TRdxFrameProveedores).TablaProveedores;
  with TablaProveedores do begin
    Codigo.MaxLength := FieldByName('CODIGO').Size;
    Nombre.MaxLength := FieldByName('NOMBRE').Size;
    NIFCIF.MaxLength := FieldByName('NIFCIF').Size;
  end;
end;

procedure TfrBuscarProveedor.bCerrarClick(Sender: TObject);
begin
  CloseFrame;
end;

procedure TfrBuscarProveedor.BuscarProveedor;
var
  Respuesta : integer;
  Resultado : Boolean;
begin
  if Contador <> -1 then begin
    TablaProveedores.DisableControls;

    if Contador = 0 then
      Resultado := TablaProveedores.LocateNext(Campos, Valores[Contador], [loCaseInsensitive, loPartialKey])
    else
      Resultado := TablaProveedores.LocateNext(Campos, Valores, [loCaseInsensitive, loPartialKey]);
    if (Resultado = false) then
    begin
        Respuesta := VerMensajePregunta(msgIrInicio);
        case Respuesta of
          IDYES: TablaProveedores.First;
        end;
    end;
    TablaProveedores.EnableControls;
  end;

end;

procedure TfrBuscarProveedor.bBuscarClick(Sender: TObject);
begin
  RecogerDatos;
  if Contador <> -1 then
    BuscarProveedor
  else
    VerMensaje(msgNoParametros);
end;

procedure TfrBuscarProveedor.RecogerDatos;
begin
  Campos := '';
  Contador := -1;

  if not EsCadenaVacia(Codigo.Text) then
  begin
    Contador := Contador + 1;
    Campos := Campos + 'CODIGO';
    Valores[Contador] := Trim(Codigo.Text);
  end;

  if not EsCadenaVacia(NIFCIF.Text) then
  begin
    Contador := Contador + 1;
    if Contador > 0 then
      Campos := Campos + ';';
    Campos := Campos + 'NIFCIF';
    Valores[Contador] := Trim(NIFCIF.Text);
  end;

  if not EsCadenaVacia(Nombre.Text) then
  begin
    Contador := Contador + 1;
    if Contador > 0 then
      Campos := Campos + ';';
    Campos := Campos + 'NOMBRE';
    Valores[Contador] := Trim(Nombre.Text);
  end;
end;

function TfrBuscarProveedor.CloseFrame: boolean;
begin
  FCodigoProveedor := TablaProveedores.FieldByName('CODIGO').AsString;
  Result := inherited CloseFrame;
end;

end.
